# -*- coding: iso_8859_1 -*-

import numpy as np
import astro

#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

#--- images ---
Folder = u"C:\\Documents and Settings\\Jrme\\Bureau\\19mar2011\\processing\\Chryseis\\"
Imagelist = ["Chryseis-calibrated-354.fit"]

#------------------------------------------------------------------------------------

im = astro.getdata(Folder, Imagelist)

astro.display(im)
print
print 'Specify boundaries of zone to be set to median image value'
xmin = np.float32(raw_input('x boundaries (vertical): xmin = '))
xmax = np.float32(raw_input('x boundaries (vertical): xmax = '))
ymin = np.float32(raw_input('y boundaries (horizontal): ymin = '))
ymax = np.float32(raw_input('y boundaries (horizontal): ymax = '))

med = astro.get_median(im)

im[xmin:xmax, ymin:ymax] = med

#------------------------------------------------------------------------------------
#	saving final image.fit
#------------------------------------------------------------------------------------
Tel = 'visac_short_f'
Exp = astro.getheadervalues(Folder, Imagelist, 'EXPOSURE')
Dateobs = astro.getheadervalues(Folder, Imagelist, 'DATE-OBS')
Obj = astro.getheadervalues(Folder, Imagelist, 'OBJECT')

headerlist = astro.create_headers(object=Obj[0], telescope=Tel, exposure=np.mean(Exp), date_obs = Dateobs[0])
astro.save_fits(im, headerlist, Folder+'Chryseis-calibrated-354(2).fit')

raw_input("Press ENTER to close")