# -*- coding: iso_8859_1 -*-

import astro
import numpy as np

#------------------------------------------------------------------------------------
#	information on source FITS images
#------------------------------------------------------------------------------------

#--- input frames ---
Folder = u"C:\\Documents and Settings\\jerome caron\\Desktop\\Perso astro\\21fev2011\\sources\\"
Imagelist = ["Chryseis\\Chryseis-aligned-" + str(i+1) + ".fit" for i in range(41)]

#--- additional information (for FITS headers) ---
Tel = 'visac_short_f'
Obj = 'NGC891'

#------------------------------------------------------------------------------------
#	loading all images
#------------------------------------------------------------------------------------

images = astro.getdata(Folder, Imagelist)

#image_final = astro.add_sigma_clipping(images, 3., 1)
image_final = astro.add_mean(images)

print
print"--- statistics of final image ---"
print "min, mean, max"
print np.min(image_final.flatten()), np.mean(image_final.flatten()), np.max(image_final.flatten())
astro.display(image_final)

#------------------------------------------------------------------------------------
#	saving final image.fit
#------------------------------------------------------------------------------------

Exp = astro.getheadervalues(Folder, Imagelist, 'EXPOSURE')
Dateobs = astro.getheadervalues(source_Folder, Imagelist, 'DATE-OBS')

headerlist = astro.create_headers(object=Obj, telescope=Tel, exposure=np.mean(Exp), date_obs = Dateobs[0])
astro.save_fits(image_final, [headerlist], Folder, ['image-final.fit'])

raw_input("Press ENTER to close")

